﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;

namespace _122618
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("sapID", typeof(string));
            dt.Columns.Add("Some Value", typeof(string)).DefaultValue = "Some Value";

            for (int i = 0; i < 140000; i++)
            {
                dt.Rows.Add(i.ToString("000000"));
            }
            grdSAPMaterials.EventManager.SetEnabled(Infragistics.Win.UltraWinGrid.GridEventIds.AfterSelectChange, false);
            grdSAPMaterials.DataSource = dt;

        }

        private void NavigateTo(string sapId)
        {
            if (grdSAPMaterials.Rows.Count > 0)
            {
                listBox1.Items.Add(string.Format("SelectChanged event is ENABLED: {0}", checkBox1.Checked));
                DateTime d = DateTime.Now;
                var row = grdSAPMaterials.Rows.AsParallel().AsEnumerable().FirstOrDefault(r => r.Cells["sapID"].Text == sapId);
                listBox1.Items.Add(string.Format("Search takes: {0}", DateTime.Now - d));
                if (row != null)
                {
                    grdSAPMaterials.BeginUpdate();
                    d = DateTime.Now;
                    grdSAPMaterials.Rows.ColumnFilters.ClearAllFilters();
                    listBox1.Items.Add(string.Format("ClearAllFilters takes : {0}", DateTime.Now - d));
                    d = DateTime.Now;
                    row.Activate();
                    listBox1.Items.Add(string.Format("Activate takes: {0}", DateTime.Now - d));
                    d = DateTime.Now;
                    grdSAPMaterials.Selected.Rows.Clear();
                    listBox1.Items.Add(string.Format("SelectedClear takes: {0}", DateTime.Now - d));
                    d = DateTime.Now;
                    row.Selected = true;
                    listBox1.Items.Add(string.Format("Selected takes: {0}", DateTime.Now - d));
                    grdSAPMaterials.EndUpdate();
                }
            }
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            NavigateTo("130000");
        }



        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
           // if(((CheckBox)sender).Checked)
            grdSAPMaterials.EventManager.SetEnabled(Infragistics.Win.UltraWinGrid.GridEventIds.AfterSelectChange, ((CheckBox)sender).Checked);
               // grdSAPMaterials.AfterSelectChange += new Infragistics.Win.UltraWinGrid.AfterSelectChangeEventHandler(grdSAPMaterials_AfterSelectChange);
        }

        private void grdSAPMaterials_AfterSelectChange_1(object sender, Infragistics.Win.UltraWinGrid.AfterSelectChangeEventArgs e)
        {
            Thread.Sleep(3000);
        }

    }
}
